import 'package:flutter/material.dart';
import 'dart:async';

import 'package:flutter/services.dart';
import 'package:matmflutterplugin/matmflutterplugin.dart';
import 'package:android_intent/android_intent.dart';
import 'package:flutter/material.dart';
import 'package:flutter/services.dart';
import 'package:flutter_appavailability/flutter_appavailability.dart';
import 'package:intent/extra.dart';
import 'package:store_redirect/store_redirect.dart';
import 'package:intent/intent.dart' as android_intent;
import 'package:intent/extra.dart' as android_extra;
import 'package:intent/typedExtra.dart' as android_typedExtra;
import 'package:intent/action.dart' as android_action;

void main() {
  runApp(MyApp());

}

class MyApp extends StatefulWidget {
  @override
  _MyAppState createState() => _MyAppState();
}

 class _MyAppState extends State<MyApp> {
  String _platformVersion = 'Unknown';

  Future<void> loadMATMSDK() {
    try {
      final AndroidIntent intent = const AndroidIntent(
        package: "com.microatm.services",
        componentName: 'com.microatm.services.Activities.MainActivity',
        action: 'action_view',
        arguments: <String, dynamic>{
          'mobileNo': '9821020369',
          'agent_id': '2190',
          'developer_id': "BANKIT",
          'password': "BANKIT",
          'partnerAgentId': '',
          'clientTransactionId': "1212212121212",
        },
      );
      intent.launch();
    } catch (e) {
      showAppNotAvailableDialog(context, "Please download mATM Service");
    }
  }

  @override
  void initState() {
    super.initState();
    initPlatformState();

  }


  // Platform messages are asynchronous, so we initialize in an async method.
  Future<void> initPlatformState() async {
    String platformVersion;
    // Platform messages may fail, so we use a try/catch PlatformException.
    try {
      platformVersion = await Matmflutterplugin.platformVersion;
    } on PlatformException {
      platformVersion = 'Failed to get platform version.';
    }

    // If the widget was removed from the tree while the asynchronous platform
    // message was in flight, we want to discard the reply rather than calling
    // setState to update our non-existent appearance.
    if (!mounted) return;

    setState(() {
      _platformVersion = platformVersion;
    });
  }

  @override
  Widget build(BuildContext context) {
    return MaterialApp(
      home: Scaffold(
        appBar: AppBar(
          title: const Text('Plugin example app'),
        ),
        body: Center(
          child: Text('Running on: $_platformVersion\n'),
        ),
      ),
    );
  }

  showAppNotAvailableDialog(BuildContext context, String message) {
    // set up the buttons

    Widget launchButton = FlatButton(
      child: Text("Download  Service"),
      onPressed: () {
        StoreRedirect.redirect(
            androidAppId: "com.microatm.services", iOSAppId: "");
        Navigator.pop(context);
      },
    );

    Widget closeButton = FlatButton(
      child: Text("Cancel"),
      onPressed: () {
        Navigator.pop(context);
      },
    );
    // set up the AlertDialog
    AlertDialog alert = AlertDialog(
      content: Text(message),
      actions: [launchButton, closeButton],
    );

    // show the dialog
    showDialog(
      context: context,
      builder: (BuildContext context) {
        return alert;
      },
    );
  }
}
